/*
 *    macros.H --- All the macros.
 *                      Part of Foamho, a sl3-homology calculator.
 *
 * Copyright (C) 2012/2013 Lukas Lewark <lewark@math.jussieu.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

#define VERSION "1.1"

#define VECVECINT std::vector<std::vector<int> >
#define VECINT std::vector<int>

#define POS_CROS 1
#define NEG_CROS 2
#define SEGMENT 3
#define POINTED_SEGMENT 6

#define OPTION_TITLE 0
#define OPTION_HELP 1
#define OPTION_ERROR 2
#define OPTION_GOOD 3

#define MALLOC_ERROR 3
#define DT_ERROR_DOUBLE_OCCURENCE 1
#define DT_ERROR_LINK 2
#define DT_ERROR_NOT_WELL_DEFINED 3

#define DEBUG
#define COUNTERS

#define MAKE_GREEN "\033[32m"
#define MAKE_RED "\033[31m"
#define MAKE_BLUE "\033[34m"
#define MAKE_YELLOW "\033[43m"
#define MAKE_GRENK "\033[44m"
#define MAKE_GRAY "\033[47m"
#define RESET_COLOR "\033[m"
#define MARK_UP "\033[1m"
#define NO_MARK_UP "\033[m"

#define WEBCONT std::vector

#define IPOINTCONT std::list
#define OEDGECONT std::list
#define BOUNDARIESCONT std::list
#define EDGECONT std::list
#define FACETCONT std::list
#define SINGULARCONT std::list
#define FOAMCONT std::list

#define ROWCOLCONT std::deque
#define ENTRYCONT std::list

#define NO_RASMUSSEN (unsigned)(-1)
