/*
 *    output.H --- Wraps some of the output.
 *                      Part of Foamho, a sl3-homology calculator.
 *
 * Copyright (C) 2012/2013 Lukas Lewark <lewark@math.jussieu.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

/* Prints the Poincare polynomial of the q-graded homology of a chain
 * complex of ccSpacesSize modules in a human readable format.
 *
 * QIdx is the number of different q-gradings occurring, and shiftedMinQ
 * is the smallest present q-degree.
 */
void printHomology(unsigned int ccSpacesSize, int tShift, unsigned int QIdx,
        int shiftedMinQ, std::vector<std::vector<unsigned int> > &homDims,
        std::vector<torstruct> torsion, bool rational, bool reduced,
        bool addInfo);
void printRasmussen(const std::vector<unsigned> &s, unsigned page2RasCandidate,
        int shift);
void printVVi(VECVECINT &v);
void printTitle();
void printHelp();
