/*
 *    parser.C --- Parse the command line parameters and the
 *                 link diagram.
 *                      Part of Foamho, a sl3-homology calculator.
 *
 * Copyright (C) 2012/2013 Lukas Lewark <lewark@math.jussieu.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

int parseCommandLine(int argc, char* argv[], optionArray &oa);

/* Three functions which convert input to the program's native format */

/* For the moment, only knots are accepted, not links,
 * because determining the sign of a crossing (dt_sign)
 * works only for knots. To be changed in a future version...
 */
bool dtToVUiv(char *&str, VECVECINT *v);
bool braidNotationToVUiv(char *&str, VECVECINT *v);
bool pdToVUiv(char *&str, VECVECINT *v);


void removeKink(VECVECINT &v, int i, int idx, int &maxStrandNumber);
void removeAllKinks(VECVECINT &v);
bool strToUiv(char *&str, VECINT *uiv, char prefix = 0);
bool strToVUiv(char *&str, VECVECINT *v, char prefix = 0);
