/*
 *    rat.H --- Wrapper for the arbitrary-precision rationals
 *              (or integers) of the mpir-library.
 *                      Part of Foamho, a sl3-homology calculator.
 *
 * Copyright (C) 2012/2013 Lukas Lewark <lewark@math.jussieu.fr>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

class ratio {
    public:
        static bool useRationals;
        /* In fact, val points to a mpir-library-rational or integer
         * (mpq_t or mpz_t). But to allow the inclusion of this header
         * file without having to include the mpir-library, val is defined
         * as pointer to void.
         */
        void *val;

        ~ratio();
        ratio();
        explicit ratio(const int &other);
        ratio(const ratio &other);
        void operator=(const ratio &other);

        void inv();
        ratio operator+=(const ratio& r);
        ratio operator*=(const ratio& r);
        bool isInvertible() const;
        bool isNonZero() const;
};
